//---------------------------------------------------------------------------
// TuScopa v0.037  (Stegh Traibaj & Tludet Dejouga Eldoeu j Pirlunsteset)
// Copyleft 1998 ACME Inc (ex Tugomira Soft)
//---------------------------------------------------------------------------
// main di debug del progetto tu scopa:  Maindeb.cpp
//---------------------------------------------------------------------------
#include <vcl\condefs.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#pragma hdrstop

#include "tuscopa.h"
#include "stocasti.h"
#include "Maindeb.h"
#include "motore01.h"
//#include "motore02.h"
//#include "motore03.h"
//#include "motore04.h"
//#include "motore05.h"
#include "motore07.h"
//---------------------------------------------------------------------------
USERES("Maindeb.res");
USEUNIT("stocasti.cpp");
USEUNIT("TuScopa.cpp");
USEUNIT("motore01.cpp");
USEUNIT("motore07.cpp");
//---------------------------------------------------------------------------
const char *vsemi = "QCFP";
const char *vvalo = "?1234567JQK";
//---------------------------------------------------------------------------
// DEB serve solo per la versione testo di debug
// stampa gruppo di carte
void visucarte(Gruppo *g)
{
 int v,s;
 for (v=1; v<=10; v++)
  for (s=0; s<4; s++)
   if (g->info[v][s].edentro) printf("-%c%c",vvalo[v],vsemi[s]);
}
//---------------------------------------------------------------------------
// DEB serve solo per la versione testo di debug
// stampa carte in mano ai giocatori
void visuinmano(AGruppo *t)
{
 int chi;
 for (chi = 0; chi<4;chi++)
 {
  printf("Giocatore %d :",chi);
  visucarte(&(t->arr[chi]));
  printf("\n");
 }
}

//---------------------------------------------------------------------------
// DEB serve solo per la versione testo di debug
// carte a terra prese e carta giocata
void visualizzaG(int chi,Risultato *r, Stato *s)
{
 printf("\nCarta giocata da %d\n",chi);
 printf("\nPoggiata: %c%c\n",
  vvalo[r->mossa.poggia.valore],vsemi[r->mossa.poggia.seme]);
 printf("Info carta: chi %d quando %d somma %d",
  s->terra.info[r->mossa.poggia.valore][r->mossa.poggia.seme].chi,
  s->terra.info[r->mossa.poggia.valore][r->mossa.poggia.seme].quandoin,
  s->terra.info[r->mossa.poggia.valore][r->mossa.poggia.seme].somma);
 if (r->mossa.prendi.tot > 0)
 {
  printf("\nCarte prese: ");
  visucarte(&(r->mossa.prendi));
 }
 printf("\nCarte a terra");
 visucarte(&(s->terra));
}

//---------------------------------------------------------------------------
// DEB valido solo per la versione testo di debug
// Routine di DEBug
void visufinale(Stato stato)
{
  printf("\nRisultato FINALE Partita\n");
  printf(" Primi  Ori carte scope pun pa di o n c\n");  //DEB
 // totale primiera
 printf(" %2d,%2d ",
   	contaprim(stato.stat[NS].prim),contaprim(stato.stat[EO].prim));
 // numero ori e carte
 printf(" %d,%d %2d,%2d ",
   	stato.stat[NS].nori,
    stato.stat[EO].nori,
   	stato.prese[NS].tot,
    stato.prese[EO].tot );
 // numero di scope
 printf(" %d,%d ",
   	stato.spunti.scope[NS],stato.spunti.scope[EO]);
 // punteggio delle quadre
 printf(" %d,%d ",
   	stato.spunti.punti[NS],stato.spunti.punti[EO]);
 // numero di carte pari e dispari
 printf(" %d,%d",
 	contapari(&stato),contadispari(&stato));
 // puo fare: ori,napula,carte
 printf("  %d %d %d",pori(&stato),pnapula(&stato),pcarte(&stato));
 // stato della napula
 printf(" %d,%d ",
   	stato.stat[NS].stanap,
    stato.stat[EO].stanap);
 printf("\n");
 // punteggio
 printf("Parziale %d %d Tot %d %d",stato.spunti.punti[NS],stato.spunti.punti[EO],
 			stato.tuttipunti[NS],stato.tuttipunti[EO]);
 printf("\n");
}
//---------------------------------------------------------------------------
// Routine di DEBug
void visueuristica(int v,int squ,Giocata mossa,Stato stato)
{
 //carta poggiata e valore euristica
 printf("(%c%c,%4d) ",
 	vvalo[mossa.poggia.valore],vsemi[mossa.poggia.seme],v);
 // totale primiera
 printf(" %2d,%2d ",
   	contaprim(stato.stat[NS].prim),contaprim(stato.stat[EO].prim));
 // numero ori e carte
 printf(" %d,%d %2d,%2d ",
   	stato.stat[NS].nori,
    stato.stat[EO].nori,
   	stato.prese[NS].tot,
    stato.prese[EO].tot );
 // numero di scope
 printf(" %d,%d ",
   	stato.spunti.scope[NS],stato.spunti.scope[EO]);
 // punteggio parziale delle quadre
 printf(" %d,%d ",
   	stato.spunti.punti[NS],stato.spunti.punti[EO]);
 // numero di carte pari e dispari
 printf(" %d,%d",
 	contapari(&stato),contadispari(&stato));
 // puo fare: ori,napula,carte
 printf("  %d %d %d",pori(&stato),pnapula(&stato),pcarte(&stato));
 // stato della napula
 printf(" %d,%d ",
   	stato.stat[NS].stanap,
    stato.stat[EO].stanap);
 printf("\n");
}
//---------------------------------------------------------------------------
// Routine di DEBug
void visuGioco(int chi, Risultato ris, Stato ora)
{
  printf("\nCarte rimaste: \n");   			//DEB
  visuinmano(&tuttelecarte);       			//DEB
  printf("\n");                    			//DEB
  visualizzaG(chi,&ris,&ora);      			//DEB
  printf("\n");                    			//DEB
  //getchar();                       		//DEB
}

//---------------------------------------------------------------------------
// fai mano
// deb a true visualizza informazioni di debug
void mano(bool deb,int nmani,int chidimazzo,Stato *ora)
{
 int quando,chi,squadra;

 chi = daimazzo(chidimazzo,ora);
 for (quando=0; quando<40; quando++)// per tutte le carte
 {
  cambiaturno(quando,&chi,&squadra,&tuttelecarte,ora);

  // motore Ai
  if (squadra == NS)
    ris = scopaduro07(0,40-quando,chi,squadra,*ora);
  else
    ris = scopaduro07(0,40-quando,chi,squadra,*ora);

  cambiastato(chi,quando,ris.mossa,oras.inmano,ora);

  if (deb)
  {
   visuGioco(chi,ris,*ora);    	// DEB
   //getchar();                    // DEB  <---------------------getchar
  }
 }
 prendiultime(ora);
 contapunti(ora);

 if (deb)
 {
  visualizzaG(chi,&ris,ora);     //DEB
  visufinale(*ora);              //DEB
 }
}
//---------------------------------------------------------------------------
int partita(bool deb,int *primomazzo,Stato *ora)
{
 int mani,vinto;
 //init
 //initpriori(); 							// DEB non ancora utilizzato
 iniziapartita(ora);
 //sino alla fine di una mano a 21
 for (mani =0; !finegioco(21,&vinto,ora); mani++)
 {
  initstato(ora);
  distribuisci(&tuttelecarte);


  if (deb)
  {
  //IO
   printf("carte distribuite:\n");     		//DEB
   visuinmano(&tuttelecarte);              	//DEB
   printf("\n");                        	//DEB
   //getchar();                       		//DEB
  }
  mano(deb,mani,(mani + *primomazzo)%4,ora);
 }
 if (deb)
  visufinale(*ora);                        //DEB

 *primomazzo = (ora->mazziere + 1)%4;
 return vinto;
}

//---------------------------------------------------------------------------
int main(int argc, char **argv)
{
 int primo =0;
 //srand(2343);
 srand(42666);
 partita(true,&primo,&oras);
 
 return 0;
}
//---------------------------------------------------------------------------
