//---------------------------------------------------------------------------
// TuScopa v0.047 (Stegh Traibaj & Tludet Dejouga Eldoeu j Pirlunsteset)
// Copyleft 1998 ACME Inc (ex Tugomira Soft)
//---------------------------------------------------------------------------
#include <vcl\condefs.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#pragma hdrstop
//---------------------------------------------------------------------------
USERES("mainstat.res");
USEUNIT("motore01.cpp");
USEUNIT("TuScopa.cpp");
USEUNIT("stocasti.cpp");
USEUNIT("motore07.cpp");
//---------------------------------------------------------------------------
#include <vcl\condefs.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#pragma hdrstop

#include "tuscopa.h"
#include "stocasti.h"

#include "motore01.h"
#include "motore07.h"
//---------------------------------------------------------------------------
const char *vsemi = "QCFP";
const char *vvalo = "?1234567JQK";

// qunti punti sono stati fatti divisi per tipo
typedef struct
{
 int settebello[2],carte[2],primiera[2],ori[2],napula[2],scope[2],tot[2];
} Sommapunti;
//---------------------------------------------------------------------------
void initsommapunti(Sommapunti *s)
{
  s->carte[NS] = 0;
  s->ori[NS]= 0;
  s->primiera[NS]= 0;
  s->settebello[NS]= 0;
  s->scope[NS]= 0;
  s->napula[NS]= 0;

  s->carte[EO]= 0;
  s->ori[EO]= 0;
  s->primiera[EO]= 0;
  s->settebello[EO]= 0;
  s->scope[EO]= 0;
  s->napula[EO]= 0;
}
//---------------------------------------------------------------------------
void visupunti(Sommapunti s)
{
 printf("NS: ca %4d or %4d pr %4d sb %4d sc %4d, na %4d\n",
   s.carte[NS],s.ori[NS],s.primiera[NS],s.settebello[NS],
   s.scope[NS],s.napula[NS]);
 printf("EO: ca %4d or %4d pr %4d sb %4d sc %4d, na %4d\n",
   s.carte[EO],s.ori[EO],s.primiera[EO],s.settebello[EO],
   s.scope[EO],s.napula[EO]);
}
//---------------------------------------------------------------------------
void fasommapunti(Punti *p,Sommapunti *s)
{
 if (p->settebello >= 0)
  s->settebello[p->settebello]++;
 if (p->carte >= 0)
  s->carte[p->carte]++;
 if (p->primiera >= 0)
  s->primiera[p->primiera]++;
 if (p->ori >= 0)
  s->ori[p->ori]++;

 if (p->napula >= 0)
  s->napula[p->napula] += p->quantinapula;

 s->scope[NS] += p->scope[NS];
 s->scope[EO] += p->scope[EO];

 s->tot[NS] += p->punti[NS];
 s->tot[EO] += p->punti[EO];

}
//---------------------------------------------------------------------------
// fai mano
// deb a true visualizza informazioni di debug
Punti mano(bool deb,int nmani,int chidimazzo,Stato *ora)
{
 int quando,chi,squadra;
 Punti punti;
 
 chi = daimazzo(chidimazzo,ora);
 for (quando=0; quando<40; quando++)// per tutte le carte
 {
  cambiaturno(quando,&chi,&squadra,&tuttelecarte,ora);

  // motore Ai
  if (squadra == NS)
    ris = scopaduro01(0,40-quando,chi,squadra,*ora);
  else
    ris = scopaduro07(0,40-quando,chi,squadra,*ora);

   cambiastato(chi,quando,ris.mossa,oras.inmano,ora);
 }
 prendiultime(ora);
 punti = contapunti(ora);

 return punti;
}
//---------------------------------------------------------------------------
int partita(bool deb,int *primomazzo,Stato *ora,Sommapunti *sommapunti)
{
 int mani,vinto;
 Punti punti;


 //init
 //initpriori(); 							// DEB non ancora utilizzato
 iniziapartita(ora);
 //sino alla fine di una mano a 21
 for (mani =0; !finegioco(21,&vinto,ora); mani++)
 {
  initstato(ora);
  distribuisci(&tuttelecarte);

  punti = mano(deb,mani,(mani + *primomazzo)%4,ora);
  fasommapunti(&punti,sommapunti);
 }
 visupunti(*sommapunti);
 *primomazzo = (ora->mazziere + 1)%4;

 return vinto;
}
//---------------------------------------------------------------------------
void debstatistica(void)
{
// DEB fare diventare procedura
 int vinto, deb,primomazzo, debvinto[2];
 Sommapunti sommapunti;
 //init
 initsommapunti(&sommapunti);
 debvinto[0] = 0;
 debvinto[1] = 0;

 srand(42666);
 //DEB per un po di volte per fare una statistica
 for (primomazzo = 0,deb = 0; deb<300; deb++)
 {
  // DEB bisogna scegliere a caso chi fa per primo il mazzo (ora a zero 0)
  vinto = partita(false,&primomazzo,&oras,&sommapunti);
  debvinto[vinto]++;
  printf("\nNORD SUD = %d EST OVEST = %d\n",debvinto[NS],debvinto[EO]);
  //getchar();
 }
}
//---------------------------------------------------------------------------
int main(int argc, char **argv)
{
 debstatistica();

 return 0;
}
//--------------------------------
